#include "KMotionDef.h"
#ifndef TMP
#define TMP 10 // which spare persist to use to transfer data
#include "KflopToKMotionCNCFunctions.c"
#endif

#include "InitConfig.c"
#include "MPGWatch.c"
#include "EmergencyWatch.c"
#include "InputUtils.c"
#include "ManualToolExchangeWatch.c"
#include "Homing.c"
#include "Spindle.c"
#include "PersistTool.c"
#include "TableSelectionWatch.c"
#include "Magazine.c"
#include "Drill.c"
#include "Saw.c"
#include "ProgramExecute.c"

// Initialization program that runs when the Init button is pressed inside KMotionCNC
// It initializes the boards, monitors alarms and listen to the IOs of the machine
void main()
{
    IOboardsConfig();
    Delay_sec(3);
    InitialEmergencyMonitoring();
    // Confirms if there is an emergency to be solved before init.
    if (GetEmergencyState() == 1)
	{
		MsgBox("Resolva a condicao de emergencia antes de inicializar", MB_ICONEXCLAMATION);
        return;
	}

    // Initializes KFlop and Kanalog board
    InitConfig();
    // Updates current milling tool in use
    int currentTool;
    if(!GetCurrentMillTool(&currentTool))
    {
        persist.UserData[PREVIOUS_MILL_TOOL_VAR] = currentTool;
    }

    // monitor external buttons, MPG and Emergency variables
    for(;;)
    {
        ManualToolExchangeWatch();
        BasicServiceMPG();
        LoopEmergencyMonitoring();
        Table1SelectionWatch();
        Table2SelectionWatch();
        Table1And2SelectionWatch();
        MagazineWatch();
        
        WaitNextTimeSlice();
    }
    
}
