#ifndef MillChangerDefs_h
#define MillChangerDefs_h

// Commom inputs, outputs and vars for the milling tool manual and automatic exchange
// Outputs to be controled for tool exchange
#define EXTRACT_OUTPUT 1130
#define OPEN_TOOL_GRIPPER_OUTPUT 1131

// check if Current Mill Tool number Valid
// -1 = no tool loaded
// 1-10 = valid tool
BOOL MillToolNumberValid(int tool)
{
	return tool == -1 || (tool>=1 && tool<=10);
}

// check if Current Tool number Valid
// -1 = no tool loaded
// 1-10 = valid tool
BOOL ToolNumberValid(int tool)
{
	return (tool>=1 && tool<=42);
}

#endif /* MillChangerDefs_h */
