#include "KMotionDef.h"
#include "PersistTool.h"
#include "MillChangerDefs.h"

#ifndef TMP
#define TMP 10 // which spare persist to use to transfer data
#include "KflopToKMotionCNCFunctions.c"
#endif


void SaveCurrentTool(int slot)
{
    printf("SaveCurrentTool %d \n", slot);
    persist.UserData[CURRENT_TOOL_VAR]=slot;
    int currentMillTool;
    GetCurrentMillTool(&currentMillTool);
    FILE *filePtr;
    filePtr = fopen(TOOL_DISK_FILE, WRITE_MODE);
    fprintf(filePtr,"%s%d\n", CURRENT_TOOL_STRING,slot);
    fclose(filePtr);

    filePtr = fopen(TOOL_DISK_FILE, APPEND_MODE);
    fprintf(filePtr,"%s%d\n", CURRENT_TOOL_SPINDLE_STRING, currentMillTool);
    fclose(filePtr);
}

void SaveCurrentMillTool(int millSlot)
{
    printf("SaveCurrentMillTool %d \n", millSlot);
    persist.UserData[PREVIOUS_MILL_TOOL_VAR]=millSlot;
    RewriteCurrentTool();
    FILE *filePtr;
    filePtr = fopen(TOOL_DISK_FILE, APPEND_MODE);
    fprintf(filePtr, "%s%d\n", CURRENT_TOOL_SPINDLE_STRING, millSlot);
    fclose(filePtr);
}

// Get the current tool.  Parameter points to where to return tool
// First try to get from KFLOP memory
// if memory is invalid, try to read from disk
// if can't read disk then ask Operator
// returns 0 on success, 1 on fail or Operator asked to abort
int GetCurrentTool(int *ptool)
{
    int success, Answer, tool;
	float value;

	tool = persist.UserData[CURRENT_TOOL_VAR];
	success = ToolNumberValid(tool);  // check if valid

    if (success)
    {
        *ptool = tool;
    }

    if (!success)   // invalid after power up, try to read from PC Disk File
	{
		// Try to open file
        FILE *filePtr;
        filePtr = fopen(TOOL_DISK_FILE, READ_MODE);
        char line[100];

        char toolStr[MAX_SIZE_TOOL_NUMBER];
        if ( filePtr != NULL )
        {
            fgets(line, sizeof line, filePtr);
            memcpy( toolStr, &line[START_CURRENT_TOOL_INDEX], MAX_SIZE_TOOL_NUMBER - 1);
            int castResult = sscanf(toolStr, "%d", ptool);
            if (castResult != 1) // convert and return result to caller
            {
                *ptool = 0;
            }
            fclose(filePtr);

            if (ToolNumberValid(*ptool))
			{
				printf("Read Disk File Value of %d\n", *ptool);
				success = TRUE; // success if one value converted
			}
        }
        else
        {
            if (!success) printf("Unable to open/read file:%s\n",TOOL_DISK_FILE);
        }
    }

    if (!success)   // if still no success ask Operator
	{
		Answer = InputBox("Tool in use",&value);
		if (Answer)
		{
			printf("Operator Canceled\n");
			return 1; // error
		}
		else
		{
			tool = value;
			printf("Operator Entered Value of %d\n",tool);
            *ptool = tool;
		}

        if (!ToolNumberValid(tool))  // check if invalid
        {
            char s[80];
            sprintf(s,"Numero %d da ferramenta atual é invalido\n",tool);
            printf(s);
            MsgBox(s, MB_ICONHAND | MB_OK);
            return 1; // error
        }
	}

    printf("Current tool = %d\n", *ptool);
    return 0; //success
}

// Get the current tool.  Parameter points to where to return tool
// First try to get from KFLOP memory
// if memory is invalid, try to read from disk
// if can't read disk then ask Operator
// returns 0 on success, 1 on fail or Operator asked to abort
int GetCurrentMillTool(int *ptool)
{
    int success, Answer, tool;
	float value;

	tool = persist.UserData[PREVIOUS_MILL_TOOL_VAR];
    printf("tool %d \n", tool);
	success = MillToolNumberValid(tool);  // check if valid

    if (success)
    {
        *ptool = tool;
    }

    if (!success)   // invalid after power up, try to read from PC Disk File
	{
        FILE *filePtr;
        filePtr = fopen(TOOL_DISK_FILE, READ_MODE);
        char line[100];

        int count = 0;
        const int currentMillToolLine = 1;
        char toolStr[MAX_SIZE_TOOL_NUMBER];
        if ( filePtr != NULL )
        {
            // The following is an algorithm to read a file line by line extracted from:
            // https://stackoverflow.com/questions/21114591/c-programming-read-specific-line-from-text-file
            while (fgets(line, sizeof line, filePtr) != NULL) /* read a line */
            {
                if (count == currentMillToolLine)
                {
                    memcpy( toolStr, &line[START_CURRENT_MILL_TOOL_INDEX], MAX_SIZE_TOOL_NUMBER -1);
                    int castResult = sscanf(toolStr, "%d", ptool);
                    printf("ptool %d, castRestult %d \n", *ptool, castResult);
                    if (castResult != 1) // convert and return result to caller
                    {
                        *ptool = 0;
                    }
                }
                else
                {
                    count++;
                }
            }
            fclose(filePtr);

            if (MillToolNumberValid(*ptool))
			{
				printf("Read Disk File Value of %d\n", *ptool);
				success = TRUE; // success if one value converted
			}
        }
        else
        {
            if (!success) printf("Unable to open/read file:%s\n",TOOL_DISK_FILE);
        }
    }

    if (!success)   // if still no success ask Operator
	{
		Answer = InputBox("Tool in Spindle or -1",&value);
		if (Answer)
		{
			printf("Operator Canceled\n");
			return 1; // error
		}
		else
		{
			tool = value;
			printf("Operator Entered Value of %d\n",tool);
            *ptool = tool;
		}

        if (!MillToolNumberValid(tool))  // check if invalid
        {
            char s[80];
            sprintf(s,"Numero %d da ferramenta atual é invalido\n",tool);
            printf(s);
            MsgBox(s, MB_ICONHAND | MB_OK);
            return 1; // error
        }
	}

    printf("Current mill tool = %d\n", *ptool);
    return 0; //success
}

void RewriteCurrentTool()
{
    printf("RewriteCurrentTool. Begin\n");
    int currentTool;
    GetCurrentTool(&currentTool);
    FILE *filePtr;
    filePtr = fopen(TOOL_DISK_FILE, WRITE_MODE);
    fprintf(filePtr, "%s%d\n", CURRENT_TOOL_STRING, currentTool);
    fclose(filePtr);
    printf("RewriteCurrentTool. End\n");
}

void UpdateCurrentToolLabel(int currentTool)
{
    printf("UpdateCurrentToolLabel\n");
    char s[80];
    // Now compute and form result
	sprintf(s,"%d",currentTool);
    // Put it onto the Screen
	DROLabel(1000, PREVIOUS_MILL_TOOL_LABEL_VAR, s);
}
