#ifndef PersistTool_h
#define PersistTool_h

// Vars
#define CURRENT_TOOL_VAR 170
#define PREVIOUS_MILL_TOOL_VAR 191
#define PREVIOUS_MILL_TOOL_LABEL_VAR 192

#define TOOL_DISK_FILE "c:\\Kmotion435h\\KMotion\\Data\\ToolChangerData.txt"

#define MAX_SIZE_TOOL_NUMBER 3 // Limits to read tools from 0 to 99

#define CURRENT_TOOL_STRING "Current tool: "
#define START_CURRENT_TOOL_INDEX 15 - 1
#define CURRENT_TOOL_SPINDLE_STRING "Current tool in Spindle: "
#define START_CURRENT_MILL_TOOL_INDEX 26 - 1

#define WRITE_MODE "w"
#define APPEND_MODE "a"
#define READ_MODE "r"

// Save information about the current tool in use.
void SaveCurrentTool(int slot);

// Save information about the current milling tool in the spindle.
void SaveCurrentMillTool(int millSlot);

// Get information from file about the current tool in use.
int GetCurrentTool(int *ptool);

// Get information from file of the current milling tool in the spindle.
int GetCurrentMillTool(int *ptool);

// Rewrite file with current tool information.
// Required when saving new tool info
void RewriteCurrentTool();

// Display methods
void UpdateCurrentToolLabel(int currentTool);

#endif /* PersistTool_h */
